\chapter{Particle Flow Jets Training of the Deep Learning based Heavy-Flavour Tagger} \label{chap:ftag:dl1:pflow}
 \btag is crucial for most physics analyses in ATLAS. Therefore it is important to provide a collaboration-wide tagger recommendation as well as its calibration. In this thesis, the \btag algorithm is studied and optimised to be provided for the whole collaboration. All studies in this chapter use particle flow jets, which is the default jet collection in ATLAS since 2020.\\
 The previous \btag algorithm was optimised for \emtopo. To improve the \btag performance even further the algorithms are reoptimised (retrained) for \pflow.
The main focus lies on the \dlr tagger, which includes the RNNIP information and should become the new default $b$-tagger in ATLAS.\\
First, some general training optimisation studies are shown in Section~\ref{sec:ftag:pflow:optimisation}, followed by a dedicated hyperparameter optimisation on ATLAS GRID GPUs in Section~\ref{sec:ftag:pflow:hpopt}, continued with a comparison of the different tagger variants and the final performance overview in Section~\ref{sec:ftag:pflow:perfoverview}.

\section{Training Optimisation} \label{sec:ftag:pflow:optimisation}
This section describes several smaller studies dealing with different improvements and physics implications for the training of the tagger.

\subsection{Smoothing Final Discriminant}\label{sec:ftag:pflow:finaldiscriminant}
The discriminant $\mathcal{D}_b$ as defined in Equation~\eqref{eq:dl1_b} is used to determine the \acfp{wp} which define if a jet is considered to be a \bjet{}. In Figure~\ref{fig:ftag:perf:dl1discold} the discriminant of the 2018 \dlb version~\cite{ATLAS-CONF-2017-013} (previous tagger iteration) is shown. The \acsp{wp} are indicated as vertical dashed lines. Especially the $60\%$ \acs{wp} is critical since it is exactly at an edge of a peak in the \bjet{} distribution. This can lead to a jump in the efficiency if a slight change occurs.
\begin{figure}[h]
    \centering
    \includegraphics[width=.6\textwidth]{b-tagging/material_dl1_general/pflow/dl1_disc_old.pdf}
    \caption{\textit{Baseline DL1} discriminant from the previous tagger iteration (2018), the vertical dashed lines are indicating the official \btag \aclp{wp}.}
    \label{fig:ftag:perf:dl1discold}
\end{figure}
Ideally, the distribution should be smoother to avoid such edge cases. Several studies were performed adapting the \acs{nn} architecture to trace down the cause of this effect. It turned out that the usage of \textit{Dropout} caused this peaky distribution. This most probably happens since the information about the default value is crucial for a good training and if this information does not get properly propagated through the network (which can happen by dropping certain node connections) it can influence the training process. Typically, \textit{Dropout} makes the training more robust but in this specific case, it causes an effect which should be avoided. Therefore, in the following model optimisation \textit{Dropout} is not used.\\
However, \textit{Dropout} was not the only reason for this effect though the dominant one. Switching to the newer keras version (from keras1 to keras2) and using the resampling approach was also resulting in a smoother output distribution. Figure~\ref{fig:ftag:perf:dl1discnodrop} shows the final discriminant for a training with the new setup and a comparable sample size to what was used in the previous iteration. The hyperparameters for this setup are summarised in Table~\ref{tab:ftag:pflow:hps-nodrop}.
The distribution is much smoother, especially for \bjets and thus a more robust working point definition is possible.
\begin{figure}[h]
    \centering
    \includegraphics[width=.6\textwidth]{b-tagging/material_dl1_general/pflow/dl1_disc_new_updated.pdf}
    \caption{\textit{Baseline DL1} discriminant for a revised training after removing Dropout, updating to Keras2 and making use of resampling. The dashed lines show different \bjet efficiencies corresponding to the \btag WPs.}
    \label{fig:ftag:perf:dl1discnodrop}
\end{figure}


\begin{table}[h!]
    \centering
    \renewcommand{\arraystretch}{0.6}
    \begin{tabular}{ll}
    \toprule
         \textbf{Hyperparameter} & \textbf{Value}  \\
         \toprule
         $N_\text{hidden layers}$ &  $8$ \vspace{0.3cm} \\
         $N_\text{nodes/layer}$ &  $[72,\,57,\,60,\, 48,\, 36,\, 24,\, 12,\, 6]$ \vspace{0.3cm} \\
         learning rate &  $0.01$ \vspace{0.3cm} \\
         Training batch size &  $4000$ \vspace{0.3cm} \\
         Training sample size &  $5.1$M jets\\
        \bottomrule
    \end{tabular}
    \caption{Hyperparameters used for the revised \dlb training using Keras2 and resampling.}
    \label{tab:ftag:pflow:hps-nodrop}
\end{table}

% \improvement{replace the DL1 discriminant and check if normalisations are ok. add the fc values -> should be both the same}


\subsection{Training Sample Statistic Implications}
In the previous iteration of the \acs{dl1} tagger~\cite{ATLAS-CONF-2017-013}, a training set statistic of 5.1M jets was used and the reweighting approach was applied. In this section, the implications of the training sample statistic are being tested.
The preprocessing is the same for all samples as described in Section~\ref{sec:ftag:dl1:preprocessing} and is based on the resampling approach.\\ 
The training sample size is altered between 4.5M and 22M jets to study its influence on the learning process. In a first step, three different training statistics are tested (4.5M, 6.2M and 8.3M) while keeping the network architecture identical. The resulting performances are shown in Figure~\ref{fig:ftag:pflow:trainstat} as the blue (4.5M), orange (6.2M) and green (8.3M) lines. For both the \cjet and light-flavour jet rejection no big differences are visible between the trainings with 4.5M or 6.2M input jets. There is a small improvement in the light-flavour jet rejection by using 8.3M jets in the training. In general, all plots of this type have binomial uncertainties indicated as their width. They are larger for the light-flavour jet rejection since more jets are rejected yielding a lower statistic, especially for lower \bjet efficiencies.\\
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=.5\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-statistic-comp}} %\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=.5\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-statistic-comp}}
    \caption{Performance comparison of different \dlr tagger setups for different training sample statistics, (a) shows the \cjet rejection and (b) the light-flavour jet rejection as a function of the \bjet efficiency. The coloured band indicates the binomial uncertainty.}
  \label{fig:ftag:pflow:trainstat}
\end{figure}



In the next step, the \acs{nn} architecture is adapted to be more complex, leaving the \acs{nn} more freedom to adjust the weights with larger training statistics, in this case 8.3M jets. Clearly, the performance improves for both \cjet and light-flavour jet rejection. Finally, the maximally available sample size of 22M jets is employed which is limited by the amount of available \cjet{}s in the \ttbar sample due to the undersampling approach. The performance improves by almost $20\%$ in the light-flavour jet rejection and in the \cjet rejection at a \bjet efficiency of $60\%$ compared to the training with 4.5M training jets shown in Figure~\ref{fig:ftag:pflow:trainstat}.\\
\begin{table}[h!]
    \centering
    \renewcommand{\arraystretch}{0.6}
    \begin{tabular}{llll}
    \toprule
         \textbf{Hyperparameter} & \textbf{Baseline NN} & \textbf{Complex NN (8.3M)} & \textbf{NN (22M)}  \\
         \toprule
         $N_\text{hidden layers}$ &  $8$  & $8$ & $8$ \vspace{0.3cm}\\
         $N_\text{nodes/layer}:1^\text{st},2^\text{nd}$  &   $[72,\, 57]$  & $[128,\, 72]$ & $[256,\, 128]$  \vspace{0.3cm}\\
         $N_\text{nodes/layer}:3^\text{rd}-8^\text{th}$  &   \multicolumn{3}{c}{$[60,\, 48,\, 36,\, 24,\, 12,\, 6]$}  \vspace{0.3cm}\\
         Learning rate &  $0.01$ & $0.01$ & $0.01$  \vspace{0.3cm}\\
         Activation function &  ReLu  & ReLu & ReLu \vspace{0.3cm}\\
         Training batch size &  $3000$  & $5000$ & $15000$ \vspace{0.3cm}\\
        %  Training sample statistic &  6M & x & x\\
        \bottomrule
    \end{tabular}
    \caption{Overview of hyperparameters used for the training statistic studies.}
    \label{tab:ftag:pflow:hps-statistics}
\end{table}


The hyperparameters of the different networks are listed in Table~\ref{tab:ftag:pflow:hps-statistics}. 
The complexity of the networks are enhanced by increasing the number of nodes in the first and second hidden layers. In addition, the training batch size is raised for larger statistics. Besides speeding up the training, since fewer iterations over the training sample are necessary, also the performance increased by adapting the batch size.








To perform the \acs{nn} training with 22M jets it is necessary to change the training procedure. Usually, the training sample is loaded into memory and the computation unit can directly access the data. These 22M jets, however, do not fit into the memory anymore and a different procedure needs to be established. The training sample needs to be read from the disk in batches during the training. In order to speed this up, the process is parallelised with so-called \textit{pipelining}. The CPU is reading the batches from the disk and preparing it. The training itself is then performed on the GPU in parallel as illustrated in Figure~\ref{fig:ftag:perf:pipeline-tf}. This can be realised with tools from keras and TensorFlow.

\begin{figure}[htbp]
    \centering
    \includegraphics[width=1.\textwidth]{b-tagging/material_dl1_general/pipelining-tf.pdf}
    \caption{Schematic of the parallel training with CPUs and GPUs. The CPU reads the batches from the disk and prepares them to feed them to the GPU, which is performing the training.}
    \label{fig:ftag:perf:pipeline-tf}
\end{figure}

However, not only the training procedure but also the preprocessing needs to be adapted.
The shuffling of the training dataset which is normally done by the keras framework, needs to be done now by hand before the training. The shuffling is done to ensure an adequate representation of the training sample in each training batch.

\subsection{Performance Monitoring}
To monitor the training process and directly check for possible overfitting as well as getting a first performance measure, several quantities are evaluated and stored during the training. The monitoring is designed such that it is possible to check the evolution already during the training.\\
Besides the loss and accuracy shown in Figure~\ref{fig:ftag:train-monitor}, also the \cjet and light-flavour jet rejection for the $77\%$ \acs{wp} are evaluated, as illustrated in Figure~\ref{fig:ftag:monitor-rej}.
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pflow-loss-monitor.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pflow-accuracy-monitor.pdf}}
  \caption{Training and validation (a) loss and (b) accuracy as a function of the training epoch. \dlr training with 22M training jets as indicated in Table~\ref{tab:ftag:pflow:hps-statistics}.}
  \label{fig:ftag:train-monitor}
\end{figure}
The presented training is performed with the input variables for \dlr and 22M training jets using the hyperparameters listed in Table~\ref{tab:ftag:pflow:hps-statistics}. All distributions evaluated on the \ttbar validation set show fluctuations up to epoch 100 and then converge. The $Z'$ sample is only used for the high \pt extension in the training while the physics sample of interest is \ttbar. Therefore \ttbar only is used as validation sample to monitor the performance. The worse performance of the hybrid training sample in terms of the loss in Figure~\ref{fig:ftag:train-monitor}~(a)  and the accuracy in Figure~\ref{fig:ftag:train-monitor}~(b) is due to the different sample composition. Generally, the \ttbar sample shows a better performance.\\

\begin{figure}[htbp]
    \centering
    \includegraphics[width=1.\textwidth]{b-tagging/material_dl1_general/pflow/pflow-monitor.pdf}
    \caption{Light-flavour jet rejection (green) and \cjet rejection (orange) as a function of the training epoch evaluated on the validation \ttbar sample during the training. \dlr training with 22M training jets as indicated in Table~\ref{tab:ftag:pflow:hps-statistics}.}
    \label{fig:ftag:monitor-rej}
\end{figure}
% \improvement{add hybrid test set in loss and accuracy}

To further check the stability of the training, several epochs 
are evaluated in more detail in Figure~\ref{fig:ftag:pflow:epocheval}. Also there, the same trend is visible: while the first epochs still show fluctuations with respect to each other, the results for the epochs 120 and 150 are almost identical. For instance, the improved \cjet rejection in epoch 3 is coming with a trade-off in its light-flavour jet rejection.  In addition, the two epochs 120 and 150 are performing best overall for the light-flavour jet rejection and also very well in the \cjet rejection. \\
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=0.5\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-epochs-comp}}%\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.5\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-epochs-comp}}
    \caption{Epoch comparison of \dlr training for (a) the \cjet rejection and (b) light-flavour jet rejection.}
  \label{fig:ftag:pflow:epocheval}
\end{figure}

Due to the convergence of the background rejections, overfitting can be excluded. This can be also shown by evaluating the \cjet rejection for a subset of \ttbar of the training sample and the validation sample shown in Figure~\ref{fig:ftag:overtrain-rej}. There are differences visible but there is no clear trend of the validation set being less performant than the training sample.
\begin{figure}[htbp]
    \centering
    \includegraphics[width=.6\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-overtrain.pdf}
    \caption{\cjet rejection as a function of the \bjet efficiency evaluated on the training and validation \ttbar sample for $\pt<\unit[250]{GeV}$. \dlr training with 22M training jets as indicated in Table~\ref{tab:ftag:pflow:hps-statistics}.}
    \label{fig:ftag:overtrain-rej}
\end{figure}

% \improvement{add another overtraining check -> evaluation on training ttbar sample}

% \subsection{Training Sample}
% \subsubsection{Composition}

\subsection{Optimisation of \cjet Fraction}
The free parameter $f_c$ in the final discriminant indicated in Equation~\eqref{eq:dl1_b} needs to be optimised for the individual trainings. A scan through different values of $f_c$ is shown in Figure~\ref{fig:ftag:fcscan} for the \dlr training with 22M training jets as shown in Table~\ref{tab:ftag:pflow:hps-statistics}. It nicely demonstrates the performance shift from the \cjet rejection towards the light-flavour jet rejection by lowering the value of $f_c$ and vice versa. Finding the optimal value for $f_c$ requires the input from physics analyses stating which quantity (\cjet or light-flavour jet rejection) is more important.
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-fc-comp.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-fc-comp.pdf}}
  \caption{Scanning of several $f_c$ values for the \dlr tagger with 22M training jets. (a) shows the \cjet rejection and (b) the light-flavour jet rejection.}
  \label{fig:ftag:fcscan}
\end{figure}
In the end, a compromise has to be made covering the requirements of most analyses. A comparison of different $f_c$ performances with the previous recommendation of \dlb is illustrated in Figure~\ref{fig:ftag:fcscan2}.
The recommendations for \emtopo (DL1 (2018)) used a $f_c$ value of $0.08$ which roughly corresponds to the actual fraction of \cjet{}s in \ttbar. From these plots it turns out that $f_c=0.018$ is better suited for the new \dlr tagger, making a compromise between a better \cjet and light-flavour jet rejection. 
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-fc-recom-comb.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-fc-recom-comb.pdf}}
  \caption{Comparison of different $f_c$ values of the \dlr training with the \dlb (DL1 (2018)) training on \emtopo. (a) shows the \cjet rejection and (b) the light-flavour jet rejection.}
  \label{fig:ftag:fcscan2}
\end{figure}
The fact that the $f_c$ value needs to be smaller is due to the different composition of the training sample. Before, the \cjet{}s were only weighted to match the kinematic distributions of the \bjet{}s, now with the undersampling approach, the same amount of \cjet{}s and \bjet{}s (and light-flavour jets) are included in the training. Thus the training sees more different \cjet topologies and can learn them better. To retrieve a similar relative performance increase for \cjet{}s and light-flavour jets, the $f_c$ value needs to be smaller.
% \improvement{ensure same colouring scheme for fcs and for DL1 EMTOPO etc.}


\subsection{Choice of SMT variables}
The soft muon information as described in Section~\ref{sec:ftag:smt} is included in the \dlrmu tagger. There are three different variable combinations available to describe the soft muon information as described in Section~\ref{sec:ftag:smt}: the variable set with the old $d_0$ sign calculation, the updated $d_0$ sign calculation (see Table~\ref{tab:ftag:outputs:smt}) and the soft muon \acs{nn} combining this information (see Table~\ref{tab:ftag:outputs:smtnn}). To choose the best variable set as input for the \dlrmu training, all these variable sets are tested and their results are compared in Figure~\ref{fig:ftag:final-summarysmt}. As expected the soft muon variables with the old $d_0$ sign definitions perform the worst indicated as the red line in the plot. The combination of the new variable set combined with the soft muon \acs{nn} delivers the best results. Using the new soft muon variables alone gives similar and only marginally worse results than the combination with the \acs{nn}. The usage of the soft muon \acs{nn} variables gives a similar performance in terms of the light-flavour jet rejection and slightly worse performance in the \cjet rejection compared to using the new soft muon variables directly. The three latter variable combination sets with the updated $d_0$ sign calculation differ maximally by\linebreak roughly $2\%$.\\
In the end, the soft muon \acs{nn} output was chosen as input set to the \dlrmu tagger, to not duplicate the transferred information to the network by including the high-level information of the soft muon \acs{nn} and its input variables. In addition, it is also important to have a standalone tool as the soft muon \acs{nn} and therefore this set of input variables for the \dlrmu is chosen.\\
In general, it would be also a possibility to add an intermediate (additional) output with a separate loss for the soft muon information to the \acs{dl1} tagger which would also provide the soft muon information separately and would also pass more information to the final network in a similar manner to the \umami network described later in Section~\ref{sec:ftag:outlook:umami}.

\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-smt_comparison}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-smt_comparison}}
    \caption{Performance comparison for different sets of soft-muon variables as input for the \dlrmu tagger shown for (a) the \cjet rejection and (b) light-flavour jet rejection.}
  \label{fig:ftag:final-summarysmt}
\end{figure}
\newpage
\section{Hyperparameter Optimisation on GRID GPUs} \label{sec:ftag:pflow:hpopt}
The training optimisation from Section~\ref{sec:ftag:pflow:optimisation} gave a significant gain in the tagger performance even though the hyperparameters were so far only optimised by hand and no systematic scan was performed. There are several possibilities to do a hyperparameter scan. The classic approach is the grid-search in which a set of trainings with pre-defined hyperparameter combinations is compared to each other. This allows to cover a large phase space, however, it is also costly in computations. Often a certain phase space of the hyperparameters can be excluded by only evaluating a subset of them.\\
Besides the hyperparameter optimisation itself, a new technical infrastructure is introduced and studied in cooperation with ATLAS IT~\cite{Forti:2020nhq}. To test this new infrastructure, a heavy computational workload is required, and the grid-search is a good use case. The detailed technical setup of the hyperparameter optimisation is described in Chapter~\ref{chap:app:hp-opt}.\\
Making use of this workflow, a hyperparameter optimisation is performed for a training of the \dlr tagger. A subset of around 300 hyperparameter combinations is tested across five dimensions (3 layers, batch size and learning rate) as listed in Table~\ref{tab:ftag:pflow:hps-scan} providing in total 450 combinations. The hyperparameters are chosen such that they vary the most important hyperparameters starting from the network architecture of the complex \acs{nn} for 22M training jets in Table~\ref{tab:ftag:pflow:hps-statistics}.\\
\begin{table}[h]
    \centering
    \renewcommand{\arraystretch}{0.6}
    \begin{tabular}{ll}
    \toprule
         \textbf{Hyperparameter} & \textbf{Values}  \\
         \toprule
         $N_\text{hidden layers}$ &  $8$ \vspace{0.3cm} \\
          $N_\text{nodes/layer}:1^\text{st}$  & $128,\, 256,\, 512$    \vspace{0.3cm}\\
          $N_\text{nodes/layer}:2^\text{nd}$  & $96,\, 128,\, 256$    \vspace{0.3cm}\\
         $N_\text{nodes/layer}:3^\text{rd}$  & $60,\, 128$ \vspace{0.3cm}\\
         $N_\text{nodes/layer}:4^\text{th}-8^\text{th}$  & fixed to $[48,\, 36,\, 24,\, 12,\, 6]$ \vspace{0.3cm}\\
         learning rate &  $5$ values between $10^{-4}$ and $0.01$\vspace{0.3cm} \\
         Training batch size &  $5$ values between $20000$ and $40000$ \vspace{0.3cm} \\
         Activation function &  ReLu \vspace{0.3cm} \\
         Training sample size &  $22$M jets\\
        \bottomrule
    \end{tabular}
    \caption{Hyperparameter combinations yielding in total 450 combinations.}
    \label{tab:ftag:pflow:hps-scan}
\end{table}

Each training is performed for $130$ epochs to reach the convergence as e.g. shown in Figure~\ref{fig:ftag:monitor-rej} to avoid fluctuations. Figure~\ref{fig:ftag:hp-loss} shows the scatter plots of the validation loss and the \cjet and light-flavour jet rejection. Clearly, the validations loss seems not to be a good measure for choosing the best set of hyperparameters. The scatter plots show for both the \cjet rejection and the light-flavour jet rejection a big spread and not a common trend. Even worse, several points are clustering horizontally for similar values of the validation loss but spanning a wider range in the background rejections. This means that even if the loss stays the same, the physics results change.\\
\begin{figure}[h]
  \centering
    \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/crej-vs-loss.pdf}}\hspace{0.3cm}
    \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/urej-vs-loss.pdf}}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/loss-HP.pdf}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/bkg-rej-HP.pdf}}
  \caption{Results of the hyperparameter optimisation showing a scatter plot between the validation loss and (a) the \cjet rejection and (b) the light-flavour jet rejection at the $77\%$ \acs{wp}.}
  \label{fig:ftag:hp-loss}
\end{figure}
Therefore, another measure to quantify the performance of a hyperparameter set needs to be chosen. The hyperparameter combinations are individually ranked by their \cjet and light-flavour jet rejection at the $77\%$ \acs{wp}. Typically, in the cases where the \cjet rejection is better the light-flavour jet rejection is worse and vice versa.
% Therefore, the hyperparameter combinations are ranked separately by their \cjet and light-flavour jet rejection. Afterwards the individually best ranked combinations are compared with each other by
Afterwards the two rankings are iteratively scanned from the top to the bottom and the first hyperparameter combination which is found in both rankings is chosen as the best combination. This is not necessarily the best ranked hyperparameter set from the individual ranks.\\
% To choose the  best parameter set, the hyperparameter combination is chosen which has the highest rank in both the 
% which has the best combined rank is chosen, which is not necessarily the best ranked hyperparameter set from the individual ranks.\\
All hyperparameter combinations are visualised in the parallel coordinates plot in Figure~\ref{fig:ftag:parallelcoordinate} where the red line indicates the best hyperparameter combination.\\
\begin{figure}[h]
    \centering
    \includegraphics[width=1.1\textwidth]{b-tagging/material_hpopt/parallel_coordinate-croped-Pflow.pdf}
    \caption{Parallel coordinate plot showing the different hyperparameter combinations for the \dlr hyperparameter scan. The red line indicates the best combination.}
    \label{fig:ftag:parallelcoordinate}
\end{figure}

The best hyperparameter combination compared to the by-hand optimised network is shown in Figure~\ref{fig:ftag:hp-result}. The differences are only very small comparing the orange (by-hand optimised \acs{nn}) and green curve (best combination). While the \cjet rejection improves slightly, the light-flavour jet rejection is a bit worse for the optimised hyperparameters. This difference can be corrected by adapting the $f_c$ value shown in the red curve (by-hand optimised \acs{nn} with $f_c=0.02$) delivering the same performance as the optimised hyperparameters. It was also checked that the batch size has no big influence on the performance, as example shown in Figure~\ref{fig:ftag:pflow:hp-batch-size}, since only values between $20000$ and $40000$ are scanned and for the by hand-optimised network a batch size of $15000$ is used.\\
Since the batch size has no influence and the performance differences are marginal, the by-hand optimised hyperparameters are kept with the certitude that the network is well optimised and the optimised $f_c$ value can be kept.
\begin{figure}[h]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-hp-comp.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-hp-comp.pdf}}
  \caption{The (a) \cjet rejection and (b) light-flavour jet rejection as a function of the \bjet efficiency shown for the best hyperparameter combination in green and the by-hand optimised network for 22M training jets for two values of $f_c$ in orange and red.}
  \label{fig:ftag:hp-result}
\end{figure}
\begin{figure}[h]
    \centering
    \includegraphics[width=0.6\textwidth]{b-tagging/material_dl1_general/pflow/crej-vs-batch_size.pdf}
    \caption{Scatter plot of the results of the different hyperparameter combinations as a function of the \cjet rejection and the batch size.}
    \label{fig:ftag:pflow:hp-batch-size}
\end{figure}


\begin{table}[h]
    \centering
    \renewcommand{\arraystretch}{0.6}
    \begin{tabular}{ll}
    \toprule
         \textbf{Hyperparameter} & \textbf{Values}  \\
         \toprule
         $N_\text{hidden layers}$ &  $8$ \vspace{0.3cm} \\
          $N_\text{nodes/layer}$  & $[256, 128, 60, 48, 36, 24, 12, 6]$    \vspace{0.3cm}\\
         learning rate &  $0.01$\vspace{0.3cm} \\
         Training batch size &  $15000$ \vspace{0.3cm} \\
         Activation function &  ReLu \vspace{0.3cm} \\
         \midrule
         Free (trainable) parameters & $59,275$  \vspace{0.3cm} \\
         Fixed parameters &  $1,140$ \vspace{0.3cm} \\
         Training sample size &  $22$M jets\\
        \bottomrule
    \end{tabular}
    \caption{Final network architecture for the \dlr tagger.}
    \label{tab:ftag:pflow:final-nn}
\end{table}
% \improvement{add free parameters etc. in table}

\FloatBarrier
\section{Performance Overview and Tagger Variants Comparison}\label{sec:ftag:pflow:perfoverview}
As shown in the sketch \ref{fig:ftag:dl1structure}, three different versions of the \acs{dl1} tagger family are investigated. The \dlr version was discussed in detail above. The other two variants, the \dlb and \dlrmu are also retrained. The retraining of the \dlb is done to have a backup solution in case the \dlr tagger would have not been calibratable. This luckily turned out to not be the case~\cite{ftagcalib}. The \dlrmu variant is also retrained but not calibrated since the light-flavour jet rejection is too high and thus the uncertainties would be too large to ensure a proper calibration. Different studies were performed to adapt the \acs{nn} architecture for the \dlb and \dlrmu. The \dlr architecture described in Table~\ref{tab:ftag:pflow:final-nn} was found to  perform also well for these other two variants. The only difference is the batch size which is set to $20000$ for the \dlb and \dlrmu to speed up the training a bit with no impact on the performance.\\


The \dlr tagger outputs are shown in Figure~\ref{fig:ftag:perf:dl1r-ps} for all three output nodes providing the probabilities for every jet to be a $b$-, $c$- or light-flavour jet. In general, \bjet{}s have the largest separation from the other two flavour categories (Fig.~\ref{fig:ftag:perf:dl1r-ps}~(a)). While the \cjet{}s still show a small separation (Fig.~\ref{fig:ftag:perf:dl1r-ps}~(b)), the light-flavour jets are not well separable (Fig.~\ref{fig:ftag:perf:dl1r-ps}~(c)).
\begin{figure}[htbp]
  \centering
    \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/DL1r_pb.pdf}}\hspace{0.3cm}
    \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/DL1r_pc.pdf}}\hspace{0.3cm}
    \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/DL1r_pu.pdf}}\hspace{0.3cm}
  \caption{The network output distributions of the \dlr tagger for (a) the \bjet node (b) the \cjet node and (c) the light-flavour jet node.}
  \label{fig:ftag:perf:dl1r-ps}
\end{figure}
These outputs are then combined into the final \btag discriminant of the \dlr tagger which is shown in Figure~\ref{fig:ftag:perf:dl1rdisc}. It is a smooth curve with the \bjet{}s taking larger values with respect to the \cjet{}s and light-flavour jets. The standard ATLAS \acsp{wp} are indicated as dashed lines indicating the cut on the $\mathcal{D}_b$ discriminant.
\begin{figure}[h]
    \centering
    \includegraphics[width=1.\textwidth]{b-tagging/material_dl1_general/pflow/dl1r_disc}
    \caption{\dlr \btag discriminant separately shown for \bjet{}s (blue), \cjet{}s (orange) and light-flavour jets (green). The vertical dashed lines are indicating the official \btag \aclp{wp}.}
    \label{fig:ftag:perf:dl1rdisc}
\end{figure}
The distributions of the \dlb and \dlrmu tagger discriminants are shown in Figure~\ref{fig:ftag:perf:dl1-dl1rmudiscs}. Also, their curves are very smooth and have no sharp edges and thus the \acs{wp} definition does not suffer from the effect described in Section~\ref{sec:ftag:pflow:finaldiscriminant}. The \bjet distributions are peaking more strongly for \dlr than for \dlb for high $\mathcal{D}_b$ and even more for \dlrmu which is expected to happen since the networks have more information available to classify \bjet{}s. The $f_c$ values were separately optimised and for the \dlb the same value as for \dlr $f_c=0.018$ is used, while for \dlrmu a value of $f_c=0.03$ was found to give better performance.\\
\begin{figure}[htbp]
  \centering
    \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/dl1_disc}}\hspace{0.3cm}
    \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/dl1rmu_disc}}
  \caption{The (a) \dlb and (b) \dlrmu  discriminants, the vertical dashed lines are indicating the different \aclp{wp}.}
  \label{fig:ftag:perf:dl1-dl1rmudiscs}
\end{figure}






% \subsection{Performance Comparison of Tagger Variants}
The \pt dependent performance is representatively evaluated for the $77\%$ \acs{wp}. Figure~\ref{fig:ftag:pflow:pt-flat-comp} and \ref{fig:ftag:pflow:pt-flat-comp-extZ} show the \pt dependent background rejection for a \ttbar and an \textit{extended} $Z'$ sample, respectively. In this case, the \bjet efficiency of $\epsilon_b=77\%$ is kept constant per \pt bin. Overall, the expected trend that \dlr outperforms the \dlb and \dlrmu outperforms \dlr is visible in all four plots in every bin.
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/c-rejection_vs_pT_flatEff_DL1-22M-ttbar-WP_77.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/l-rejection_vs_pT_flatEff_DL1-22M-ttbar-WP_77.pdf}}
  \caption{\pt dependent performance for a constant \bjet efficiency of $77\%$ per bin for the (a) \cjet rejection and (b) light-flavour jet rejection for the \ttbar sample.}
  \label{fig:ftag:pflow:pt-flat-comp}
\end{figure}
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/c-rejection_vs_pT_flatEff_DL1-22M-extZ-WP_77.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/l-rejection_vs_pT_flatEff_DL1-22M-extZ-WP_77.pdf}}
  \caption{\pt dependent performance for a constant \bjet efficiency of $77\%$ per bin for the (a) \cjet rejection and (b) light-flavour jet rejection for the \textit{extended} $Z'$ sample.}
  \label{fig:ftag:pflow:pt-flat-comp-extZ}
\end{figure}
The \pt spectrum up to \unit[250]{GeV} is shown for the \ttbar sample and the \textit{extended} $Z'$ covers the higher \pt spectrum from \unit[250]{GeV} upwards. The improvements in the \ttbar sample are almost constant over the full \pt range (Fig.~\ref{fig:ftag:pflow:pt-flat-comp}) between the three tagger variants. Therefore, the additional RNNIP and soft muon information contribute to the performance gain in this lower \pt regime. Looking at the higher \pt regime (Fig.~\ref{fig:ftag:pflow:pt-flat-comp-extZ}), the first two bins show a similar behaviour while going to higher \pt values the soft muon information is not helping anymore. Hence, the RNNIP information improves the high \pt \btag while the soft muon information is not. This comes from the fact, that the RNNIP tagger was optimised on the high \pt \textit{extended} $Z'$ sample while it is getting more difficult to extract and associate the muon information to the $b$-hadron decay for high \pt.\\

The Figures~\ref{fig:ftag:pflow:pt-incl-comp} and \ref{fig:ftag:pflow:pt-incl-comp-zprime} show the inclusive $77\%$ \acs{wp}, which is defined on an inclusive \ttbar sample including all data taking periods\footnote{As a reminder, these performance plots are only evaluated on the 2017 data taking period pile-up profile.}, and is evaluated on the \ttbar and \textit{extended} $Z'$ sample, respectively. The \bjet efficiency plot for \ttbar in Figure~\ref{fig:ftag:pflow:pt-incl-comp}~(c) reveals that the \bjet efficiency is not flat as a function of \pt but increasing with \pt. All three taggers show the same trend in terms of the increasing \bjet efficiency. Consequently, the \cjet rejection (Fig.~\ref{fig:ftag:pflow:pt-incl-comp}~(a)) and the light-flavour jet rejection (Fig.~\ref{fig:ftag:pflow:pt-incl-comp}~(b)) are much flatter than for the above case where the \bjet efficiency was maintained for every single bin. Similar to the constant \bjet efficiency the three taggers have the same performance behaviour with respect to each other ($\dlb<\dlr<\dlrmu$).\\
\begin{figure}[h]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/c-rejection_vs_pT_DL1-22M-ttbar-WP_77.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/l-rejection_vs_pT_DL1-22M-ttbar-WP_77.pdf}}\\
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/b-efficiency_vs_pT_DL1-22M-ttbar-WP_77.pdf}}
  \caption{\pt dependent performance for an inclusive \bjet efficiency of $77\%$ defined on an inclusive \ttbar sample (official ATLAS cut value) for the (a) \cjet rejection, (b) light-flavour jet rejection and (c) the $b$-jet efficiency as a function of \pt for the \ttbar sample.}
  \label{fig:ftag:pflow:pt-incl-comp}
\end{figure}
\begin{figure}[h]
  \centering
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/c-rejection_vs_pT_DL1-22M-extZ-WP_77.pdf}}\hspace{0.3cm}
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/l-rejection_vs_pT_DL1-22M-extZ-WP_77.pdf}}\\
  \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/pflow/pts/b-efficiency_vs_pT_DL1-22M-extZ-WP_77.pdf}}
  \caption{\pt dependent performance for an inclusive \bjet efficiency of $77\%$ defined on an inclusive \ttbar sample (official ATLAS cut value) for the (a) \cjet rejection, (b) light-flavour jet rejection and (c) the $b$-jet efficiency as a function of \pt for the \textit{extended} $Z'$ sample.}
  \label{fig:ftag:pflow:pt-incl-comp-zprime}
\end{figure}
In contrast, the performance behaviour on the \textit{extended} $Z'$ sample changes more drastically with the inclusive \bjet efficiency. As illustrated in Figure~\ref{fig:ftag:pflow:pt-incl-comp-zprime}~(c), the \bjet efficiency decreases drastically for higher \pt values. The RNNIP information stabilises this decrease a bit as well as the soft muon information while the \dlb shows a larger decrease down to about $5\%$ at \unit[5]{TeV} compared to slightly more than $10\%$ for \dlr and \dlrmu. This behaviour is also reflected in the background rejection. For both, the \cjet rejection (Fig.~\ref{fig:ftag:pflow:pt-incl-comp-zprime}~(a)) and the light-flavour jet rejection (Fig.~\ref{fig:ftag:pflow:pt-incl-comp-zprime}~(b)) show an inverted performance compared to what is usually expected. Already in the second \pt bin for the \cjet rejection the \textit{performance order} is inverted which means that the \dlb has a higher rejection than \dlr and \dlr higher than \dlrmu. For the light-flavour rejection, this effect is starting in the $4^\text{th}$ \pt bin. However, appearances are deceiving since the lower \bjet efficiencies in the higher \pt bins cause this inversion. Therefore, the background rejections are higher but also less \bjet{}s are passing this selection.\\
% l-rejection_vs_pT_flatEff_DL1-22M-extZ-WP_77.pdf
% l-rejection_vs_pT_DL1-22M-extZ-WP_77.pdf
% c-rejection_vs_pT_flatEff_DL1-22M-extZ-WP_77.pdf
% c-rejection_vs_pT_DL1-22M-extZ-WP_77.pdf
% b-efficiency_vs_pT_DL1-22M-extZ-WP_77.pdf


The comparison of the full \bjet efficiency spectrum is illustrated in Figure~\ref{fig:ftag:pflow:tagger-comp} for the \ttbar sample. Including the RNNIP information in the tagger training improves the \cjet rejection constantly by about $15\%$ over a wide \bjet efficiency range ($60\%$ to $\sim80\%$). Similarly, the additional soft muon information gives another $\sim20\%$ between $60\%$ and $\sim75\%$ \bjet efficiency. For higher \bjet efficiencies the performance differences are decreasing for the \cjet rejection but are still around $5\%$ to $\sim15\%$ at a \bjet efficiency of $85\%$, which is the loosest \acs{wp} used in ATLAS.\\
The light-flavour jet rejection (Fig.~\ref{fig:ftag:pflow:tagger-comp}~(b)) improves with the RNNIP information by almost $25\%$ over the full \bjet efficiency spectrum relevant for the \acs{wp} definition, it even increases more for a \bjet efficiency of $\sim84\%$ compared to the \dlb. Another $10\%$ performance gain is achieved adding the soft muon information, again applicable over the full \bjet efficiency range relevant for the \acsp{wp}.\\
Even though the \dlrmu tagger performs best, it cannot be used in physics analyses since it is not possible to calibrate the light-flavour mis-tag rate. As pointed out in Section~\ref{sec:ftag:intro:calib}, if the light-flavour jet rejection is too high, the uncertainties on the scale factors are getting really large due to drastically reduced statistics. While this can be overcome for \dlr by using a \textit{flipped tagger} (see sec.~\ref{sec:ftag:intro:calib}), this is not possible for the \acs{smt} information.
\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=1.\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-tagger-comp}}\\
  \subfloat[]{\includegraphics[width=1.\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-tagger-comp}}
  \caption{Performance comparison of the three different \acs{dl1} tagger versions: \dlb (blue), \dlr (red) and \dlrmu (orange) for the (a) \cjet rejection and (b) light-flavour jet rejection as a function of the \bjet efficiency.}
  \label{fig:ftag:pflow:tagger-comp}
\end{figure}



% PFlow_c-rej_beff-tagger-comp
% performance_plots/pts/b-efficiency_vs_pT_DL1-22M-ttbar-WP_77.pdf          
%  performance_plots/pts/l-rejection_vs_pT_DL1-22M-ttbar-WP_77.pdf
% performance_plots/pts/c-rejection_vs_pT_DL1-22M-ttbar-WP_77.pdf           
\FloatBarrier
\subsection{Comparison to previous Recommendations}
Before the \dlr taggers were retrained and reoptimised, the recommended taggers were the \textit{MV2c10} tagger and the previous iteration of the \dlb tagger (DL1 (2018)), both optimised on \emtopo. The new recommendation is now to use the \dlr tagger for particle flow jets, provided to the whole ATLAS collaboration. A comparison of the two previous recommendations and the new recommendation is shown in Figure~\ref{fig:ftag:pflow:tagger-comp-recomm}. Compared to \textit{MV2c10}, the new \dlr improves by up to $70\%$ and $120\%$ for the \cjet and light-flavour jet rejection, respectively, evaluated at the $60\%$ \acs{wp}. This major improvement leads to gains, especially in analyses which heavily depend on \btag such as the \tthbb analysis.



\begin{figure}[htbp]
  \centering
  \subfloat[]{\includegraphics[width=1.\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_c-rej_beff-tagger-ttbar-recom}}\\
  \subfloat[]{\includegraphics[width=1.\textwidth]{b-tagging/material_dl1_general/pflow/PFlow_u-rej_beff-tagger-ttbar-recom}}
  \caption{Performance comparison of the previous recommendations (MV2 and DL1 (2018)) and the newly optimised \dlr tagger for the (a) \cjet rejection and (b) light-flavour jet rejection as a function of the \bjet efficiency.}
  \label{fig:ftag:pflow:tagger-comp-recomm}
\end{figure}
% \subsection{Data Taking Period Comparison}

% \begin{figure}[htbp]
%   \centering
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/}}
%   \caption{}
%   \label{fig:ftag:}
% \end{figure}


% \improvement{add comparison of the three data taking periods}
% \begin{figure}[htbp]
%   \centering
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-Final-summary-c_rej}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-Final-summary-u_rej}}
%   \caption{UPDATE plots!!}
%   \label{fig:ftag:final-summary}
% \end{figure}


% \begin{figure}[htbp]
%   \centering
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-training-tagger-comp-DL1-c_rej}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-training-tagger-comp-DL1-l_rej}}
%   \caption{UPDATE plots!!}
%   \label{fig:ftag:final-summary1}
% \end{figure}


% \begin{figure}[htbp]
%   \centering
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-EMTopo-comp-c_rej}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-EMTopo-comp-u_rej}}\\
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-EMTopo-comp-c_rej-ext_Zprime}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-EMTopo-comp-u_rej-ext_Zprime}}
%   \caption{UPDATE plots!!}
%   \label{fig:ftag:final-summary1}
% \end{figure}


% \begin{figure}[htbp]
%   \centering
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-training-tagger-comp-c_rej}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-training-tagger-comp-l_rej}}\\
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-training-tagger-comp-c_rej-Z_prime}}\hspace{0.3cm}
%   \subfloat[]{\includegraphics[width=0.48\textwidth]{b-tagging/material_dl1_general/plots/PFlow-22M-training-tagger-comp-l_rej-Z_prime}}
%   \caption{UPDATE plots!!}
%   \label{fig:ftag:final-summary2}
% \end{figure}















